/**
 ****************************************************************************************
 *
 * @file		rble_app.h
 *
 * @brief	rBLE Sample Program
 *
 * Copyright(C) 2013-2014 Renesas Electronics Corporation
 *
 * $Rev: 7209 $
 *
 ****************************************************************************************
 */

#ifndef _rBLE_APP_H
#define _rBLE_APP_H

#include	"rble.h"
#include	"rble_api.h"
#include	"rble_api_custom.h"

/**************************** Define Declaration **************************************/
#define	ILLEGAL_NO					-1
#define	RBLE_PARAMETER_MAX			7


enum RBLE_L2CAP_PTS_TC_NO_enum {
	/* L2CAP */
	L2CAP_TC_LE_CPU_BV_01_C = 0,
	L2CAP_TC_LE_CPU_BV_02_C,
	L2CAP_TC_LE_CPU_BI_01_C,
	L2CAP_TC_LE_CPU_BI_02_C,
	L2CAP_TC_LE_REJ_BI_01_C
};

enum RBLE_GAP_PTS_TC_NO_enum {
	/* GAP */
	GAP_TC_BROB_BCST_BV_01_C = 100,
	GAP_TC_BROB_BCST_BV_02_C,
	GAP_TC_BROB_BCST_BV_03_C,
	GAP_TC_BROB_OBSV_BV_01_C,
	GAP_TC_BROB_OBSV_BV_02_C,
	GAP_TC_BROB_OBSV_BV_05_C,
	GAP_TC_DISC_NONM_BV_01_C,
	GAP_TC_DISC_NONM_BV_02_C,
	GAP_TC_DISC_LIMM_BV_03_C,
	GAP_TC_DISC_LIMM_BV_04_C,
	GAP_TC_DISC_GENM_BV_03_C,
	GAP_TC_DISC_GENM_BV_04_C,
	GAP_TC_DISC_LIMP_BV_01_C,
	GAP_TC_DISC_LIMP_BV_02_C,
	GAP_TC_DISC_LIMP_BV_03_C,
	GAP_TC_DISC_LIMP_BV_04_C,
	GAP_TC_DISC_LIMP_BV_05_C,
	GAP_TC_DISC_GENP_BV_01_C,
	GAP_TC_DISC_GENP_BV_02_C,
	GAP_TC_DISC_GENP_BV_03_C,
	GAP_TC_DISC_GENP_BV_04_C,
	GAP_TC_DISC_GENP_BV_05_C,
	GAP_TC_IDLE_NAMP_BV_01_C,
	GAP_TC_IDLE_NAMP_BV_02_C,
	GAP_TC_CONN_NCON_BV_01_C,
	GAP_TC_CONN_NCON_BV_02_C,
	GAP_TC_CONN_NCON_BV_03_C,
	GAP_TC_CONN_DCON_BV_01_C,
	GAP_TC_CONN_UCON_BV_01_C,
	GAP_TC_CONN_UCON_BV_02_C,
	GAP_TC_CONN_UCON_BV_03_C,
	GAP_TC_CONN_ACEP_BV_01_C,
	GAP_TC_CONN_GCEP_BV_01_C,
	GAP_TC_CONN_GCEP_BV_02_C,
	GAP_TC_CONN_SCEP_BV_01_C,
	GAP_TC_CONN_DCEP_BV_01_C,
	GAP_TC_CONN_DCEP_BV_03_C,
	GAP_TC_CONN_CPUP_BV_01_C,
	GAP_TC_CONN_CPUP_BV_02_C,
	GAP_TC_CONN_CPUP_BV_03_C,
	GAP_TC_CONN_CPUP_BV_04_C,
	GAP_TC_CONN_CPUP_BV_05_C,
	GAP_TC_CONN_CPUP_BV_06_C,
	GAP_TC_CONN_TERM_BV_01_C,
	GAP_TC_CONN_PRDA_BV_01_C,
	GAP_TC_CONN_PRDA_BV_02_C,
	GAP_TC_BOND_NBON_BV_01_C,
	GAP_TC_BOND_NBON_BV_02_C,
	GAP_TC_BOND_NBON_BV_03_C,
	GAP_TC_BOND_BON_BV_01_C,
	GAP_TC_BOND_BON_BV_02_C,
	GAP_TC_BOND_BON_BV_03_C,
	GAP_TC_BOND_BON_BV_04_C,
	GAP_TC_SEC_AUT_BV_11_C,
	GAP_TC_SEC_AUT_BV_12_C,
	GAP_TC_SEC_AUT_BV_13_C,
	GAP_TC_SEC_AUT_BV_14_C,
	GAP_TC_SEC_AUT_BV_17_C,
	GAP_TC_SEC_AUT_BV_19_C,
	GAP_TC_SEC_AUT_BV_21_C,
	GAP_TC_SEC_AUT_BV_23_C,
	GAP_TC_SEC_AUT_BV_24_C,
	GAP_TC_SEC_CSIGN_BV_01_C,
	GAP_TC_SEC_CSIGN_BV_02_C,
	GAP_TC_SEC_CSIGN_BI_01_C,
	GAP_TC_SEC_CSIGN_BI_02_C,
	GAP_TC_SEC_CSIGN_BI_03_C,
	GAP_TC_SEC_CSIGN_BI_04_C,
	GAP_TC_PRIV_CONN_BV_10_C,
	GAP_TC_PRIV_CONN_BV_11_C,
	GAP_TC_ADV_BV_01_C,
	GAP_TC_ADV_BV_02_C,
	GAP_TC_ADV_BV_03_C,
	GAP_TC_ADV_BV_04_C,
	GAP_TC_ADV_BV_05_C,
	GAP_TC_ADV_BV_06_C,
	GAP_TC_ADV_BV_07_C,
	GAP_TC_ADV_BV_08_C,
	GAP_TC_ADV_BV_09_C,
	GAP_TC_ADV_BV_10_C,
	GAP_TC_ADV_BV_11_C,
	GAP_TC_ADV_BV_12_C,
	GAP_TC_ADV_BV_13_C,
	GAP_TC_ADV_BV_14_C,
	GAP_TC_ADV_BV_15_C,
	GAP_TC_ADV_BV_16_C,
	GAP_TC_GAT_BV_01_C,
	GAP_TC_GAT_BV_04_C,
	GAP_TC_GAT_BV_05_C,
	GAP_TC_GAT_BV_06_C
};

enum RBLE_SM_PTS_TC_NO_enum {
	/* SM */
	SM_TC_PROT_BV_01_C = 300,
	SM_TC_PROT_BV_02_C,
	SM_TC_JW_BV_01_C,
	SM_TC_JW_BV_02_C,
	SM_TC_JW_BV_05_C,
	SM_TC_JW_BI_01_C,
	SM_TC_JW_BI_02_C,
	SM_TC_PKE_BV_01_C,
	SM_TC_PKE_BV_02_C,
	SM_TC_PKE_BV_03_C,
	SM_TC_PKE_BI_01_C,
	SM_TC_PKE_BI_02_C,
	SM_TC_PKE_BI_03_C,
	SM_TC_OOB_BV_01_C,
	SM_TC_OOB_BV_02_C,
	SM_TC_OOB_BV_03_C,
	SM_TC_OOB_BV_04_C,
	SM_TC_OOB_BI_01_C,
	SM_TC_OOB_BI_02_C,
	SM_TC_EKS_BV_01_C,
	SM_TC_EKS_BV_02_C,
	SM_TC_EKS_BI_01_C,
	SM_TC_EKS_BI_02_C,
	SM_TC_SIGN_BV_01_C,
	SM_TC_SIGN_BV_03_C,
	SM_TC_SIGN_BI_01_C,
	SM_TC_KDU_BV_01_C,
	SM_TC_KDU_BV_02_C,
	SM_TC_KDU_BV_03_C,
	SM_TC_KDU_BV_04_C,
	SM_TC_KDU_BV_05_C,
	SM_TC_KDU_BV_06_C,
	SM_TC_KDU_BV_07_C,
	SM_TC_SIP_BV_01_C,
	SM_TC_SIP_BV_02_C,
	SM_TC_SIE_BV_01_C
};

enum RBLE_GATT_PTS_TC_NO_enum {
	/* GATT */
	GATT_TC_GAC_SR_BV_01_C = 2000,
	GATT_TC_GAD_CL_BV_01_C,
	GATT_TC_GAD_CL_BV_01_I,
	GATT_TC_GAD_CL_BV_02_C,
	GATT_TC_GAD_CL_BV_02_I,
	GATT_TC_GAD_CL_BV_03_C,
	GATT_TC_GAD_CL_BV_03_I,
	GATT_TC_GAD_CL_BV_04_C,
	GATT_TC_GAD_CL_BV_04_I,
	GATT_TC_GAD_CL_BV_05_C,
	GATT_TC_GAD_CL_BV_05_I,
	GATT_TC_GAD_CL_BV_06_C,
	GATT_TC_GAD_CL_BV_06_I,
	GATT_TC_GAD_SR_BV_01_C,
	GATT_TC_GAD_SR_BV_02_C,
	GATT_TC_GAD_SR_BV_03_C,
	GATT_TC_GAD_SR_BV_04_C,
	GATT_TC_GAD_SR_BV_05_C,
	GATT_TC_GAD_SR_BV_06_C,
	GATT_TC_GAR_CL_BV_01_C,
	GATT_TC_GAR_CL_BI_01_C,
	GATT_TC_GAR_CL_BI_02_C,
	GATT_TC_GAR_CL_BI_03_C,
	GATT_TC_GAR_CL_BI_04_C,
	GATT_TC_GAR_CL_BI_05_C,
	GATT_TC_GAR_CL_BV_03_C,
	GATT_TC_GAR_CL_BI_06_C,
	GATT_TC_GAR_CL_BI_07_C,
	GATT_TC_GAR_CL_BI_09_C,
	GATT_TC_GAR_CL_BI_10_C,
	GATT_TC_GAR_CL_BI_11_C,
	GATT_TC_GAR_CL_BV_04_C,
	GATT_TC_GAR_CL_BI_12_C,
	GATT_TC_GAR_CL_BI_13_C,
	GATT_TC_GAR_CL_BI_14_C,
	GATT_TC_GAR_CL_BI_15_C,
	GATT_TC_GAR_CL_BI_16_C,
	GATT_TC_GAR_CL_BI_17_C,
	GATT_TC_GAR_CL_BV_05_C,
	GATT_TC_GAR_CL_BI_18_C,
	GATT_TC_GAR_CL_BI_19_C,
	GATT_TC_GAR_CL_BI_20_C,
	GATT_TC_GAR_CL_BI_21_C,
	GATT_TC_GAR_CL_BI_22_C,
	GATT_TC_GAR_CL_BV_06_C,
	GATT_TC_GAR_CL_BI_23_C,
	GATT_TC_GAR_CL_BI_24_C,
	GATT_TC_GAR_CL_BI_25_C,
	GATT_TC_GAR_CL_BI_26_C,
	GATT_TC_GAR_CL_BI_27_C,
	GATT_TC_GAR_CL_BV_07_C,
	GATT_TC_GAR_CL_BI_28_C,
	GATT_TC_GAR_CL_BI_29_C,
	GATT_TC_GAR_CL_BI_30_C,
	GATT_TC_GAR_CL_BI_31_C,
	GATT_TC_GAR_CL_BI_32_C,
	GATT_TC_GAR_CL_BI_33_C,
	GATT_TC_GAR_CL_BI_35_C,
	GATT_TC_GAR_SR_BV_01_C,
	GATT_TC_GAR_SR_BI_01_C,
	GATT_TC_GAR_SR_BI_02_C,
	GATT_TC_GAR_SR_BI_03_C,
	GATT_TC_GAR_SR_BI_04_C,
	GATT_TC_GAR_SR_BI_05_C,
	GATT_TC_GAR_SR_BV_03_C,
	GATT_TC_GAR_SR_BI_06_C,
	GATT_TC_GAR_SR_BI_07_C,
	GATT_TC_GAR_SR_BI_08_C,
	GATT_TC_GAR_SR_BI_09_C,
	GATT_TC_GAR_SR_BI_10_C,
	GATT_TC_GAR_SR_BI_11_C,
	GATT_TC_GAR_SR_BV_04_C,
	GATT_TC_GAR_SR_BI_12_C,
	GATT_TC_GAR_SR_BI_13_C,
	GATT_TC_GAR_SR_BI_14_C,
	GATT_TC_GAR_SR_BI_15_C,
	GATT_TC_GAR_SR_BI_16_C,
	GATT_TC_GAR_SR_BI_17_C,
	GATT_TC_GAR_SR_BV_05_C,
	GATT_TC_GAR_SR_BI_18_C,
	GATT_TC_GAR_SR_BI_19_C,
	GATT_TC_GAR_SR_BI_20_C,
	GATT_TC_GAR_SR_BI_21_C,
	GATT_TC_GAR_SR_BI_22_C,
	GATT_TC_GAR_SR_BV_06_C,
	GATT_TC_GAR_SR_BI_23_C,
	GATT_TC_GAR_SR_BI_24_C,
	GATT_TC_GAR_SR_BI_25_C,
	GATT_TC_GAR_SR_BI_26_C,
	GATT_TC_GAR_SR_BI_27_C,
	GATT_TC_GAR_SR_BV_07_C,
	GATT_TC_GAR_SR_BV_08_C,
	GATT_TC_GAR_SR_BI_28_C,
	GATT_TC_GAR_SR_BI_29_C,
	GATT_TC_GAR_SR_BI_30_C,
	GATT_TC_GAR_SR_BI_31_C,
	GATT_TC_GAR_SR_BI_32_C,
	GATT_TC_GAR_SR_BI_33_C,
	GATT_TC_GAW_CL_BV_01_C,
	GATT_TC_GAW_CL_BV_02_C,
	GATT_TC_GAW_CL_BV_03_C,
	GATT_TC_GAW_CL_BI_02_C,
	GATT_TC_GAW_CL_BI_03_C,
	GATT_TC_GAW_CL_BI_04_C,
	GATT_TC_GAW_CL_BI_05_C,
	GATT_TC_GAW_CL_BI_06_C,
	GATT_TC_GAW_CL_BV_05_C,
	GATT_TC_GAW_CL_BI_07_C,
	GATT_TC_GAW_CL_BI_08_C,
	GATT_TC_GAW_CL_BI_09_C,
	GATT_TC_GAW_CL_BI_11_C,
	GATT_TC_GAW_CL_BI_12_C,
	GATT_TC_GAW_CL_BI_13_C,
	GATT_TC_GAW_CL_BV_06_C,
	GATT_TC_GAW_CL_BI_14_C,
	GATT_TC_GAW_CL_BI_15_C,
	GATT_TC_GAW_CL_BI_17_C,
	GATT_TC_GAW_CL_BI_18_C,
	GATT_TC_GAW_CL_BI_19_C,
	GATT_TC_GAW_CL_BV_07_C,
	GATT_TC_GAW_CL_BV_08_C,
	GATT_TC_GAW_CL_BI_20_C,
	GATT_TC_GAW_CL_BI_21_C,
	GATT_TC_GAW_CL_BI_22_C,
	GATT_TC_GAW_CL_BI_23_C,
	GATT_TC_GAW_CL_BI_24_C,
	GATT_TC_GAW_CL_BV_09_C,
	GATT_TC_GAW_CL_BI_25_C,
	GATT_TC_GAW_CL_BI_26_C,
	GATT_TC_GAW_CL_BI_27_C,
	GATT_TC_GAW_CL_BI_29_C,
	GATT_TC_GAW_CL_BI_30_C,
	GATT_TC_GAW_CL_BI_31_C,
	GATT_TC_GAW_CL_BI_32_C,
	GATT_TC_GAW_SR_BV_01_C,
	GATT_TC_GAW_SR_BV_02_C,
	GATT_TC_GAW_SR_BI_01_C,
	GATT_TC_GAW_SR_BV_03_C,
	GATT_TC_GAW_SR_BI_02_C,
	GATT_TC_GAW_SR_BI_03_C,
	GATT_TC_GAW_SR_BI_04_C,
	GATT_TC_GAW_SR_BI_05_C,
	GATT_TC_GAW_SR_BI_06_C,
	GATT_TC_GAW_SR_BV_05_C,
	GATT_TC_GAW_SR_BI_07_C,
	GATT_TC_GAW_SR_BI_08_C,
	GATT_TC_GAW_SR_BI_09_C,
	GATT_TC_GAW_SR_BI_11_C,
	GATT_TC_GAW_SR_BI_12_C,
	GATT_TC_GAW_SR_BI_13_C,
	GATT_TC_GAW_SR_BV_06_C,
	GATT_TC_GAW_SR_BV_10_C,
	GATT_TC_GAW_SR_BI_14_C,
	GATT_TC_GAW_SR_BI_15_C,
	GATT_TC_GAW_SR_BI_17_C,
	GATT_TC_GAW_SR_BI_18_C,
	GATT_TC_GAW_SR_BV_07_C,
	GATT_TC_GAW_SR_BV_08_C,
	GATT_TC_GAW_SR_BI_20_C,
	GATT_TC_GAW_SR_BI_21_C,
	GATT_TC_GAW_SR_BI_22_C,
	GATT_TC_GAW_SR_BI_23_C,
	GATT_TC_GAW_SR_BI_24_C,
	GATT_TC_GAW_SR_BV_09_C,
	GATT_TC_GAW_SR_BI_25_C,
	GATT_TC_GAW_SR_BI_26_C,
	GATT_TC_GAW_SR_BI_27_C,
	GATT_TC_GAW_SR_BI_29_C,
	GATT_TC_GAW_SR_BI_30_C,
	GATT_TC_GAW_SR_BI_31_C,
	GATT_TC_GAN_CL_BV_01_C,
	GATT_TC_GAN_SR_BV_01_C,
	GATT_TC_GAI_CL_BV_01_C,
	GATT_TC_GAI_SR_BV_01_C,
	GATT_TC_GAS_CL_BV_01_C,
	GATT_TC_GAS_SR_BV_01_C,
	GATT_TC_GAT_CL_BV_01_C,
	GATT_TC_GAT_CL_BV_02_C,
	GATT_TC_GAT_SR_BV_01_C,
	GATT_TC_GPA_CL_BV_01_C,
	GATT_TC_GPA_CL_BV_02_C,
	GATT_TC_GPA_CL_BV_03_C,
	GATT_TC_GPA_CL_BV_04_C,
	GATT_TC_GPA_CL_BV_07_C,
	GATT_TC_GPA_SR_BV_01_C,
	GATT_TC_GPA_SR_BV_03_C,
	GATT_TC_GPA_SR_BV_04_C,
	GATT_TC_GPA_SR_BV_07_C
};

enum RBLE_FMP_PTS_TC_NO_enum {
	/* FMP */
	FMP_TC_FMS_FL_BV_02_C = 400,
	FMP_TC_FMS_FL_BV_03_C,
	FMP_TC_FMF_FL_BV_01_C,
	FMP_TC_FMF_FL_BV_02_C,
	FMP_TC_FMF_FL_BV_03_C
};

enum RBLE_IAS_PTS_TC_NO_enum {
	/* IAS */
	IAS_TC_SD_BV_01_C = 500,
	IAS_TC_DEC_BV_01_C,
	IAS_TC_CW_BV_01_C,
	IAS_TC_SP_BV_01_C
};

enum RBLE_PXP_PTS_TC_NO_enum {
	/* PXP */
	PXP_TC_PXS_PM_BV_04_C = 600,
	PXP_TC_PXS_PM_BV_05_C,
	PXP_TC_PXS_PM_BV_06_C,
	PXP_TC_PXS_PM_BV_07_C,
	PXP_TC_PXS_PM_BV_08_C,
	PXP_TC_PXS_PM_BV_09_C,
	PXP_TC_PXF_PM_BV_01_C,
	PXP_TC_PXF_PM_BV_02_C,
	PXP_TC_PXF_PM_BV_03_C,
	PXP_TC_PXF_PM_BV_05_C,
	PXP_TC_PXF_PM_BV_06_C,
	PXP_TC_PXF_PM_BV_07_C
};

enum RBLE_LLS_PTS_TC_NO_enum {
	/* LLS */
	LLS_TC_SD_BV_01_C = 700,
	LLS_TC_DEC_BV_01_C,
	LLS_TC_CR_BV_01_C,
	LLS_TC_CW_BV_01_C,
	LLS_TC_SP_BV_01_C,
	LLS_TC_SP_BV_02_C,
	LLS_TC_SP_BV_03_C
};

enum RBLE_TPS_PTS_TC_NO_enum {
	/* TPS */
	TPS_TC_SD_BV_01_C = 800,
	TPS_TC_DEC_BV_01_C,
	TPS_TC_CR_BV_01_C
};

enum RBLE_HTP_PTS_TC_NO_enum {
	/* HTP */
	HTP_TC_THS_CO_BV_01_I = 900,
	HTP_TC_THS_CO_BV_02_I,
	HTP_TC_THS_CO_BV_04_I,
	HTP_TC_THS_CO_BV_05_I,
	HTP_TC_THS_CO_BV_07_I,
	HTP_TC_THS_CO_BV_08_I,
	HTP_TC_THS_CO_BV_09_I,
	HTP_TC_THS_CO_BV_10_I,
	HTP_TC_THS_CO_BV_11_I,
	HTP_TC_THS_CO_BV_12_I,
	HTP_TC_THS_CO_BV_13_I,
	HTP_TC_THS_CO_BV_14_I,
	HTP_TC_THF_TH_BV_01_I,
	HTP_TC_THF_TH_BV_02_I,
	HTP_TC_THF_CO_BV_01_I,
	HTP_TC_THF_CO_BV_02_I,
	HTP_TC_THF_CO_BI_01_I,
	HTP_TC_THF_CO_BI_02_I,
	HTP_TC_THF_CO_BI_03_I,
	HTP_TC_THF_CO_BV_03_I,
	HTP_TC_THF_CO_BV_04_I,
	HTP_TC_THF_CO_BV_05_I,
	HTP_TC_THF_CO_BI_04_I,
	HTP_TC_THF_CO_BI_05_I,
	HTP_TC_THF_CO_BI_06_I,
	HTP_TC_THF_CO_BV_07_I,
	HTP_TC_THF_CO_BV_08_I,
	HTP_TC_THF_CO_BV_09_I,
	HTP_TC_THF_CO_BV_10_I,
	HTP_TC_THF_CO_BV_11_I,
	HTP_TC_THF_CO_BV_12_I,
	HTP_TC_THF_CO_BV_13_I,
	HTP_TC_THF_CO_BI_07_I,
	HTP_TC_THF_CO_BV_14_I
};

enum RBLE_HTS_PTS_TC_NO_enum {
	/* HTS */
	HTS_TC_SD_BV_01_C = 1000,
	HTS_TC_DEC_BV_02_C,
	HTS_TC_DEC_BV_03_C,
	HTS_TC_DEC_BV_04_C,
	HTS_TC_DEC_BV_05_C,
	HTS_TC_DES_BV_01_C,
	HTS_TC_DES_BV_03_C,
	HTS_TC_DES_BV_04_C,
	HTS_TC_DES_BV_05_C,
	HTS_TC_CR_BV_02_C,
	HTS_TC_CR_BV_03_C,
	HTS_TC_CW_BV_02_C,
	HTS_TC_CIN_BV_01_C,
	HTS_TC_CIN_BV_02_C,
	HTS_TC_CIN_BV_03_C,
	HTS_TC_CI_BV_01_C,
	HTS_TC_CI_BV_02_C,
	HTS_TC_SP_BV_01_C,
	HTS_TC_SP_BV_02_C,
	HTS_TC_SP_BV_03_C,
	HTS_TC_SP_BI_01_C
};

enum RBLE_DIS_PTS_TC_NO_enum {
	/* DIS */
	DIS_TC_SD_BV_01_C = 1100,
	DIS_TC_DEC_BV_01_C,
	DIS_TC_DEC_BV_02_C,
	DIS_TC_DEC_BV_03_C,
	DIS_TC_DEC_BV_04_C,
	DIS_TC_DEC_BV_05_C,
	DIS_TC_DEC_BV_06_C,
	DIS_TC_DEC_BV_07_C,
	DIS_TC_DEC_BV_08_C,
	DIS_TC_DEC_BV_09_C,
	DIS_TC_CR_BV_01_C,
	DIS_TC_CR_BV_02_C,
	DIS_TC_CR_BV_03_C,
	DIS_TC_CR_BV_04_C,
	DIS_TC_CR_BV_05_C,
	DIS_TC_CR_BV_06_C,
	DIS_TC_CR_BV_07_C,
	DIS_TC_CR_BV_08_C,
	DIS_TC_CR_BV_09_C
};

enum RBLE_BLP_PTS_TC_NO_enum {
	/* BLP */
	BLP_TC_BPD_CO_BV_01_I = 1200,
	BLP_TC_BPD_CO_BV_02_I,
	BLP_TC_BPD_CO_BV_04_I,
	BLP_TC_BPD_CO_BV_05_I,
	BLP_TC_BPD_CO_BV_06_I,
	BLP_TC_BPD_CO_BV_07_I,
	BLP_TC_BPD_CO_BV_08_I,
	BLP_TC_BPD_CO_BV_09_I,
	BLP_TC_BPD_CO_BV_10_I,
	BLP_TC_BPF_BP_BV_01_I,
	BLP_TC_BPF_BP_BV_02_I,
	BLP_TC_BPF_BP_BV_03_I,
	BLP_TC_BPF_BP_BV_04_I,
	BLP_TC_BPF_BP_BV_05_I,
	BLP_TC_BPF_BP_BV_08_I,
	BLP_TC_BPF_CO_BV_09_I,
	BLP_TC_BPF_CO_BV_10_I,
	BLP_TC_BPF_CO_BI_01_I,
	BLP_TC_BPF_CO_BI_02_I,
	BLP_TC_BPF_CO_BI_03_I,
	BLP_TC_BPF_CO_BV_11_I,
	BLP_TC_BPF_CO_BV_12_I,
	BLP_TC_BPF_CO_BV_13_I,
	BLP_TC_BPF_CO_BI_04_I,
	BLP_TC_BPF_CO_BI_05_I,
	BLP_TC_BPF_CO_BI_06_I,
	BLP_TC_BPF_CO_BV_14_I,
	BLP_TC_BPF_CO_BV_15_I,
	BLP_TC_BPF_CO_BI_07_I,
	BLP_TC_BPF_CO_BV_16_I
};

enum RBLE_BLS_PTS_TC_NO_enum {
	/* BLS */
	BLS_TC_SD_BV_01_C = 1300,
	BLS_TC_DEC_BV_01_C,
	BLS_TC_DEC_BV_02_C,
	BLS_TC_DEC_BV_03_C,
	BLS_TC_DES_BV_01_C,
	BLS_TC_DES_BV_02_C,
	BLS_TC_CR_BV_01_C,
	BLS_TC_CR_BV_02_C,
	BLS_TC_CON_BV_01_C,
	BLS_TC_CON_BV_02_C,
	BLS_TC_CI_BV_01_C,
	BLS_TC_CI_BV_02_C,
	BLS_TC_CI_BV_03_C,
	BLS_TC_CI_BV_04_C,
	BLS_TC_CI_BV_05_C,
	BLS_TC_CN_BV_01_C,
	BLS_TC_CN_BV_02_C,
	BLS_TC_CN_BV_03_C,
	BLS_TC_CN_BV_04_C,
	BLS_TC_CN_BV_05_C,
	BLS_TC_SP_BV_01_C
};

enum RBLE_HOGP_PTS_TC_NO_enum {
	/* HOGP */
	HOGP_TC_HGDS_HH_BV_01_C = 1400,
	HOGP_TC_HGDS_HH_BV_02_C,
	HOGP_TC_HGDS_HH_BV_03_C,
	HOGP_TC_HGDS_HD_BV_01_C,
	HOGP_TC_HGDS_HD_BV_02_C,
	HOGP_TC_HGDR_RH_BV_01_C,
	HOGP_TC_HGDC_RH_BV_01_C,
	HOGP_TC_HGDC_RH_BV_02_C,
	HOGP_TC_HGDC_RH_BV_03_C,
	HOGP_TC_HGDC_RH_BV_04_C,
	HOGP_TC_HGDC_RH_BV_05_C,
	HOGP_TC_HGDC_RH_BV_06_C,
	HOGP_TC_HGDC_RH_BV_07_C,
	HOGP_TC_HGDC_HH_BV_08_C,
	HOGP_TC_HGDC_BH_BV_09_C,
	HOGP_TC_HGDC_BH_BV_10_C,
	HOGP_TC_HGDC_BH_BV_11_C,
	HOGP_TC_HGDC_BH_BV_12_C,
	HOGP_TC_HGDC_BH_BV_13_C,
	HOGP_TC_HGDC_HH_BV_14_C,
	HOGP_TC_HGDC_HH_BV_15_C,
	HOGP_TC_HGDC_HH_BV_16_C,
	HOGP_TC_HGRF_RH_BV_01_C,
	HOGP_TC_HGRF_RH_BV_02_C,
	HOGP_TC_HGRF_RH_BV_03_C,
	HOGP_TC_HGRF_RH_BV_04_C,
	HOGP_TC_HGRF_RH_BV_05_C,
	HOGP_TC_HGRF_RH_BV_06_C,
	HOGP_TC_HGRF_RH_BV_07_C,
	HOGP_TC_HGRF_RH_BV_08_C,
	HOGP_TC_HGRF_RH_BV_09_C,
	HOGP_TC_HGRF_HH_BV_10_C,
	HOGP_TC_HGRF_HH_BV_11_C,
	HOGP_TC_HGRF_HH_BV_12_C,
	HOGP_TC_HGRF_BH_BV_13_C,
	HOGP_TC_HGRF_BH_BV_14_C,
	HOGP_TC_HGRF_BH_BV_15_C,
	HOGP_TC_HGRF_BH_BV_16_C,
	HOGP_TC_HGRF_BH_BV_17_C,
	HOGP_TC_HGRF_HH_BV_18_C,
	HOGP_TC_HGWF_RH_BV_01_C,
	HOGP_TC_HGWF_RH_BV_02_C,
	HOGP_TC_HGWF_RH_BV_03_C,
	HOGP_TC_HGWF_RH_BV_04_C,
	HOGP_TC_HGWF_RH_BV_05_C,
	HOGP_TC_HGWF_RH_BV_06_C,
	HOGP_TC_HGWF_RH_BV_07_C,
	HOGP_TC_HGWF_BH_BV_08_C,
	HOGP_TC_HGWF_BH_BV_09_C,
	HOGP_TC_HGWF_BH_BV_10_C,
	HOGP_TC_HGWF_BH_BV_11_C,
	HOGP_TC_HGCF_RH_BV_01_C,
	HOGP_TC_HGCF_RH_BV_02_C,
	HOGP_TC_HGCF_BH_BV_03_C,
	HOGP_TC_HGCF_BH_BV_04_C,
	HOGP_TC_HGCF_BH_BV_05_C,
	HOGP_TC_HGCF_BH_BV_06_C,
	HOGP_TC_HGNF_RH_BV_01_C,
	HOGP_TC_HGNF_BH_BV_02_C,
	HOGP_TC_HGNF_BH_BV_03_C,
	HOGP_TC_HGNF_BH_BI_01_C,
	HOGP_TC_HGNF_RH_BI_01_C,
	HOGP_TC_HGNF_RH_BI_02_C
};

enum RBLE_HIDS_PTS_TC_NO_enum {
	/* HIDS */
	HIDS_TC_SD_BV_01_C = 1500,
	HIDS_TC_DEC_BV_01_C,
	HIDS_TC_DEC_BV_02_C,
	HIDS_TC_DEC_BV_03_C,
	HIDS_TC_DEC_BV_04_C,
	HIDS_TC_DEC_BV_05_C,
	HIDS_TC_DEC_BV_06_C,
	HIDS_TC_DEC_BV_07_C,
	HIDS_TC_DEC_BV_08_C,
	HIDS_TC_DES_BV_01_C,
	HIDS_TC_DES_BV_02_C,
	HIDS_TC_DES_BV_03_C,
	HIDS_TC_DES_BV_04_C,
	HIDS_TC_DES_BV_05_C,
	HIDS_TC_CR_BV_01_C,
	HIDS_TC_CR_BV_02_C,
	HIDS_TC_CR_BV_03_C,
	HIDS_TC_CR_BV_04_C,
	HIDS_TC_CR_BV_05_C,
	HIDS_TC_CR_BV_06_C,
	HIDS_TC_CR_BV_07_C,
	HIDS_TC_CR_BV_08_C,
	HIDS_TC_LCR_BV_01_C,
	HIDS_TC_LCR_BV_02_C,
	HIDS_TC_LCR_BV_03_C,
	HIDS_TC_LCR_BV_04_C,
	HIDS_TC_CON_BV_01_C,
	HIDS_TC_CON_BV_02_C,
	HIDS_TC_CON_BV_03_C,
	HIDS_TC_CN_BV_01_C,
	HIDS_TC_CN_BV_02_C,
	HIDS_TC_CN_BV_03_C,
	HIDS_TC_CW_BV_01_C,
	HIDS_TC_CW_BV_02_C,
	HIDS_TC_CW_BV_03_C,
	HIDS_TC_CW_BV_04_C,
	HIDS_TC_CW_BV_05_C,
	HIDS_TC_CW_BV_06_C,
	HIDS_TC_CW_BV_07_C,
	HIDS_TC_CW_BV_08_C,
	HIDS_TC_CW_BV_09_C,
	HIDS_TC_CW_BV_10_C,
	HIDS_TC_CW_BV_11_C,
	HIDS_TC_CW_BV_12_C,
	HIDS_TC_DR_BV_01_C,
	HIDS_TC_DR_BV_02_C,
	HIDS_TC_DR_BV_03_C,
	HIDS_TC_DR_BV_04_C,
	HIDS_TC_DR_BV_05_C,
	HIDS_TC_DW_BV_01_C,
	HIDS_TC_DW_BV_02_C,
	HIDS_TC_DW_BV_03_C,
	HIDS_TC_SP_BV_01_C
};

enum RBLE_BAS_PTS_TC_NO_enum {
	/* BAS */
	BAS_TC_SD_BV_01_C = 1600,
	BAS_TC_DEC_BV_01_C,
	BAS_TC_DES_BV_01_C,
	BAS_TC_DES_BV_02_C,
	BAS_TC_CR_BV_01_C,
	BAS_TC_CON_BV_01_C,
	BAS_TC_CN_BV_01_C
};

enum RBLE_SCPP_PTS_TC_NO_enum {
	/* ScPP */
	SCPP_TC_SPDS_SC_BV_01_C = 1700,
	SCPP_TC_SPDC_SC_BV_01_C,
	SCPP_TC_SPDC_SC_BV_02_C,
	SCPP_TC_SPDC_SC_BV_03_C,
	SCPP_TC_SPWF_SC_BV_01_C,
	SCPP_TC_SPCF_SC_BV_01_C,
	SCPP_TC_SPNF_SC_BV_01_C
};

enum RBLE_SCPS_PTS_TC_NO_enum {
	/* ScPS */
	SCPS_TC_SD_BV_01_C = 1800,
	SCPS_TC_DEC_BV_01_C,
	SCPS_TC_DEC_BV_02_C,
	SCPS_TC_DES_BV_01_C,
	SCPS_TC_CW_BV_01_C,
	SCPS_TC_DR_BV_01_C,
	SCPS_TC_DW_BV_01_C,
	SCPS_TC_CON_BV_01_C,
	SCPS_TC_CN_BV_01_C
};

enum RBLE_HRP_PTS_TC_NO_enum {
	/* HRP */
	HRP_TC_HRD_CO_BV_01_I = 1900,
	HRP_TC_HRD_CO_BV_02_I,
	HRP_TC_HRD_HR_BV_03_I,
	HRP_TC_HRD_CO_BV_04_I,
	HRP_TC_HRD_CO_BV_05_I,
	HRP_TC_HRD_CO_BV_07_I,
	HRP_TC_HRD_CO_BV_08_I,
	HRP_TC_HRD_CO_BV_09_I,
	HRP_TC_HRD_CO_BV_10_I,
	HRP_TC_HRF_HR_BV_01_I,
	HRP_TC_HRF_HR_BV_02_I,
	HRP_TC_HRF_CO_BV_03_I,
	HRP_TC_HRF_CO_BV_04_I,
	HRP_TC_HRF_CO_BI_01_I,
	HRP_TC_HRF_CO_BI_02_I,
	HRP_TC_HRF_CO_BV_05_I,
	HRP_TC_HRF_CO_BV_06_I,
	HRP_TC_HRF_CO_BI_03_I,
	HRP_TC_HRF_CO_BV_07_I,
	HRP_TC_HRF_CO_BV_08_I
};

enum RBLE_HRS_PTS_TC_NO_enum {
	/* HRS */
	HRS_TC_SD_BV_01_C = 2000,
	HRS_TC_DEC_BV_01_C,
	HRS_TC_DEC_BV_02_C,
	HRS_TC_DEC_BV_03_C,
	HRS_TC_DES_BV_01_C,
	HRS_TC_CR_BV_01_C,
	HRS_TC_CW_BV_01_C,
	HRS_TC_CW_BI_01_C,
	HRS_TC_CON_BV_01_C,
	HRS_TC_CN_BV_01_C,
	HRS_TC_CN_BV_02_C,
	HRS_TC_CN_BV_03_C,
	HRS_TC_CN_BV_04_C,
	HRS_TC_CN_BV_05_C
};

enum RBLE_CSCP_PTS_TC_NO_enum {
	/* CSCP */
	CSCP_TC_CSCD_BV_01_I = 2100,
	CSCP_TC_CSCD_BV_02_I,
	CSCP_TC_CSCD_BV_05_I,
	CSCP_TC_CSCD_BV_06_I,
	CSCP_TC_CSCD_BV_07_I,
	CSCP_TC_CSCD_BV_08_I,
	CSCP_TC_CSCD_BV_09_I,
	CSCP_TC_CSCD_BV_10_I,
	CSCP_TC_CSCD_BV_11_I,
	CSCP_TC_CSCD_BV_12_I,
	CSCP_TC_CSCF_CSC_BV_01_I,	/* 2110 */
	CSCP_TC_CSCF_CSC_BV_02_I,
	CSCP_TC_CSCF_CSC_BV_03_I,
	CSCP_TC_CSCF_CSC_BV_04_I,
	CSCP_TC_CSCF_CSC_BV_05_I,
	CSCP_TC_CSCF_CSC_BV_06_I,
	CSCP_TC_CSCF_CSC_BV_07_I,
	CSCP_TC_CSCF_CSC_BV_08_I,
	CSCP_TC_CSCF_CSC_BV_09_I,
	CSCP_TC_CSCF_CSC_BV_10_I,
	CSCP_TC_CSCF_CSC_BI_01_I,	/* 2120 */
	CSCP_TC_CSCF_CSC_BI_02_I,
	CSCP_TC_CSCF_CSC_BV_11_I,
	CSCP_TC_CSCF_CSC_BV_12_I,
	CSCP_TC_CSCF_CSC_BI_03_I,
	CSCP_TC_CSCF_CSC_BV_13_I,
	CSCP_TC_CSCF_CSC_BI_04_I,
	CSCP_TC_CSCF_CSC_BV_14_I,
	CSCP_TC_CSCF_CSC_BV_16_I,
	CSCP_TC_SPS_CO_BV_01_I,
	CSCP_TC_SPS_CO_BV_02_I,		/* 2130 */
	CSCP_TC_SPL_CO_BV_01_I,
	CSCP_TC_SPU_CO_BV_01_I,
	CSCP_TC_SPE_CO_BI_01_I,
	CSCP_TC_SPE_CO_BI_02_I,
	CSCP_TC_SPE_CO_BI_03_I,
	CSCP_TC_SPE_CO_BI_04_I
};

enum RBLE_CSCS_PTS_TC_NO_enum {
	/* CSCS */
	CSCS_TC_SD_BV_01_C = 2200
};

enum RBLE_LNS_PTS_TC_NO_enum {
	/* LNS */
	LNS_TC_CR_BV_0X_C = 2400
};

typedef struct RBLE_GAP_Observation_Enable_t {
	uint16_t			mode;
	RBLE_SCANNING_INFO	scan_info;
} RBLE_OBSERVATION_ENABLE_PARAM;

typedef struct RBLE_GAP_Broadcast_Enable_t {
	uint16_t			disc_mode;
	uint16_t			conn_mode;
	RBLE_ADV_INFO		adv_info;
} RBLE_BROADCAST_ENABLE_PARAM;

typedef struct RBLE_GAP_Privacy_Feature_Param_t {
	uint8_t				priv_flag;
	uint8_t				set_to_ll;
} RBLE_GAP_PRIV_FEAT_PRAM;

typedef struct RBLE_FMP_Locator_Set_Alert_Param_t {
	uint8_t					alert_lvl;
} RBLE_FMP_LOCATOR_SET_ALERT_PARAM;

typedef struct RBLE_HTP_Therm_Enable_Param_t {
	uint8_t					sec_lvl;
	uint8_t					con_type;
	RBLE_HTP_THERM_PARAM	param;
} RBLE_HTP_THERM_ENABLE_PARAM;

typedef struct RBLE_BLP_Write_Char_t {
	uint8_t				char_code;
	uint16_t			cfg_val;
} RBLE_BLP_WRITE_CHAR_PARAM;

typedef struct RBLE_HGP_HDevice_Enable_Param_t {
	uint8_t					sec_lvl;
	uint8_t					con_type;
	RBLE_HGP_DEVICE_PARAM	param;
} RBLE_HGP_HDEVICE_ENABLE_PARAM;

typedef struct RBLE_HGP_HDevice_Send_Report_Param_t {
	uint8_t					inst_idx;
	RBLE_HGP_REPORT_DESC	report;
} RBLE_HGP_HDEVICE_SEND_REPORT_PARAM;

typedef struct RBLE_HGP_BHost_Enable_Param_t {
	uint8_t					con_type;
	uint8_t					hids_inst_num;
	uint8_t					bas_inst_num;
	RBLE_HIDS_CONTENT		hids[RBLE_HIDS_INST_MAX];
	RBLE_DIS11_CONTENT		dis;
	RBLE_BAS_CONTENT		bas[RBLE_BAS_INST_MAX];
} RBLE_HGP_BHost_ENABLE_PARAM;

typedef struct RBLE_HGP_BHost_Send_Report_Param_t {
	uint8_t					inst_idx;
	RBLE_HGP_REPORT_DESC	report;
} RBLE_HGP_BHOST_SEND_REPORT_PARAM;

typedef struct RBLE_HGP_BHost_Data_Output_Param_t {
	uint8_t					inst_idx;
	RBLE_HGP_REPORT_DESC	report;
} RBLE_HGP_BHOST_DATA_OUTPUT_PARAM;

typedef struct RBLE_HGP_RHost_Enable_Param_t {
	uint8_t					con_type;
	uint8_t					hids_inst_num;
	uint8_t					bas_inst_num;
	RBLE_HIDS_CONTENT		hids[RBLE_HIDS_INST_MAX];
	RBLE_DIS11_CONTENT		dis;
	RBLE_BAS_CONTENT		bas[RBLE_BAS_INST_MAX];
} RBLE_HGP_RHost_ENABLE_PARAM;

typedef struct RBLE_HGP_RHost_Send_Report_Param_t {
	uint8_t					inst_idx;
	RBLE_HGP_REPORT_DESC	report;
} RBLE_HGP_RHOST_SEND_REPORT_PARAM;

typedef struct RBLE_HGP_RHost_Data_Output_Param_t {
	uint8_t					inst_idx;
	RBLE_HGP_REPORT_DESC	report;
} RBLE_HGP_RHOST_DATA_OUTPUT_PARAM;

/**************************** PUBLIC Memory Declaration *******************************/
extern uint32_t							RBLE_Parameter_Arg[ RBLE_PARAMETER_MAX ];
extern uint_t							RBLE_Parameter_Cnt;
extern const RBLE_OBSERVATION_ENABLE_PARAM		RBLE_Observation_Enable_Param[4];
extern const RBLE_BROADCAST_ENABLE_PARAM		RBLE_Broadcast_Enable_Param[22];
extern const RBLE_BOND_PARAM					RBLE_Start_Bond_Param[14];
extern const RBLE_BOND_RESP_PARAM				RBLE_Bond_Resp_Param[17];
extern const uint8_t					SCP_Char_Code[5];
extern const uint8_t					CPP_Wr_Char_Code[5];
extern const int8_t						CPP_Control_Point_Disp_Info[16][33];
extern const int8_t						LNP_Control_Point_Disp_Info[9][22];
extern RBLE_BLP_WRITE_CHAR_PARAM 		RBLE_BLP_Write_Char_Param[4];
extern const RBLE_GAP_PRIV_FEAT_PRAM	RBLE_GAP_Privacy_Feature_Param[6];
extern RBLE_FMP_LOCATOR_SET_ALERT_PARAM	RBLE_FMP_Locator_Set_Alert_Param[2];
extern RBLE_HTP_THERM_ENABLE_PARAM		RBLE_HTP_Therm_Enable_Param[2];
extern RBLE_HGP_HDEVICE_ENABLE_PARAM	RBLE_HGP_HDevice_Enable_Param[1];
extern RBLE_HGP_HDEVICE_SEND_REPORT_PARAM	RBLE_HGP_HDevice_Send_Report_Param[3];
extern RBLE_HGP_BHost_ENABLE_PARAM		RBLE_HGP_BHost_Enable_Param[1];
extern RBLE_HGP_BHOST_SEND_REPORT_PARAM	RBLE_HGP_BHost_Send_Report_Param[3];
extern RBLE_HGP_BHOST_DATA_OUTPUT_PARAM	RBLE_HGP_BHost_Data_Output_Param[1];
extern RBLE_HGP_RHost_ENABLE_PARAM		RBLE_HGP_RHost_Enable_Param[1];
extern RBLE_HGP_RHOST_SEND_REPORT_PARAM	RBLE_HGP_RHost_Send_Report_Param[3];
extern RBLE_HGP_RHOST_DATA_OUTPUT_PARAM	RBLE_HGP_RHost_Data_Output_Param[1];

/**************************** PROTOTYPE Declaration ***********************************/
#ifdef __cplusplus
extern "C" {
#endif
BOOL RBLE_App_Init( void );
#ifdef __cplusplus
}
#endif
#endif	/* _rBLE_APP_H */
